freeslot("S_PLAY_DRIFT","sfx_altdri","SPR2_DRIF")

states[S_PLAY_DRIFT] = {
	sprite = SPR_PLAY,
	frame = SPR2_DRIF,
	tics = 2,
	nextstate = S_PLAY_DRIFT
}

addHook("PlayerThink", function(p)
	if p.frontiersdrift == nil
		p.frontiersdrift = false
	end
	if p.mo.skin == "rangersonic"
	and (p.cmd.sidemove >= 30 or p.cmd.sidemove < -30)
	and p.speed >= 60*FRACUNIT
	and P_IsObjectOnGround(p.mo)
	and (p.cmd.buttons & BT_CUSTOM1)
		p.frontiersdrift = true
	end
	if p.frontiersdrift
		p.mo.state = S_PLAY_DRIFT
		P_SpawnSkidDust(p, 13*FRACUNIT)
		S_StartSound(p.mo, sfx_altdri)
	end
	if p.mo.state == S_PLAY_DRIFT
	and not p.frontiersdrift
		p.mo.state = S_PLAY_RUN
	end
	if S_SoundPlaying(p.mo, sfx_altdri)
	and p.mo.state ~= S_PLAY_DRIFT
		S_StopSoundByID(p.mo, sfx_altdri)
	end
end)

addHook("PlayerThink", function(p)
	if not P_IsObjectOnGround(p.mo)
	or p.speed < 60*FRACUNIT
	or not (p.cmd.buttons & BT_CUSTOM1)
	or not (p.cmd.sidemove)
		p.frontiersdrift = false
	end
end)